package dev.fyloz.memorycache.utils

import io.kotest.core.spec.style.ShouldSpec
import io.kotest.matchers.shouldBe

class CollectionsTest : ShouldSpec({
    context("removeFirst") {
        val collection = setOf(1, 2, 3, 4, 5)

        fun getMutableCollection() = mutableSetOf(*collection.toTypedArray())

        var mutableCollection = getMutableCollection()

        beforeEach {
            mutableCollection = getMutableCollection()
        }

        should("remove first item matching predicate from collection") {
            // Arrange
            val firstEvenItem = mutableCollection.first { it.isEven }

            // Act
            mutableCollection.removeFirst { it.isEven }

            // Assert
            val contains = firstEvenItem in mutableCollection
            contains shouldBe false
        }

        should("does not remove second item matching predicate from collection") {
            // Arrange
            val secondEvenItem = mutableCollection.nth(2) { it.isEven }

            // Act
            mutableCollection.removeFirst { it.isEven }

            // Assert
            val contains = secondEvenItem in mutableCollection
            contains shouldBe true
        }
    }
})